class GoLive {

	constructor(){
		this.config = {};
		this.countDownTime = 45;
		this.session = {};
		this.subscriber = {};
    	this.publisher = {};
    	this.count_donw_interval = {};
        this.go_live_connect = {};
    	this.chat_data = {'seller':{},'customer':{}};
	}

	show_section(section){
		jQuery(section).removeClass('go_live_hidden');
	}

	hide_section(section){
		jQuery(section).addClass('go_live_hidden');
	}

    toggle_section(section){
        jQuery(section).toggleClass('go_live_hidden');
        
    }

	height(section,height){
		jQuery(section).height(height);
	}

    width(section,width){
		jQuery(section).width(width);
	}

	show_error_message(text){
		jQuery('#error_message').text(text);
	}

	check_customer_status(){
		let go_live = this;
        go_live.width('#go_live_sidebar','300px');
        jQuery.ajax({
                data: {action: 'face2face_customer_status', f2fn: face_2_face_data.f2fn,seller_id:face_2_face_data.reciever.ID },
                type: 'post',
                url: face_2_face_data.ajax_url,
                success: function(response) {
                if(response.status){
                    console.log('I am running');
                    goLive.hide_section("#go_live_toggle");
                    go_live.show_section('#waiting_area,#videos,.go-live-btn,.go-live-content-wrapper');
                    if(response.data.sessionId!='' && response.data.tokboxToken!=''){
                        console.log('I am here');
                        go_live.config.tokboxToken=response.data.tokboxToken;
                        go_live.config.sessionId=response.data.sessionId;
                        clearInterval(go_live.count_donw_interval);
                        go_live.initialize_session();
                    
                    } else {
                        console.log('I am else');
                        go_live.hide_section('#videos,.go-live-btn');
                        go_live.show_error_message(response.message);
                        go_live.interval_count_down();
                        go_live.connect_vendor();
                    }
                } else {
                    go_live.show_section('.go-live-btn');
                }
            },
            error:function(error){
                console.log(error);
            }
        });
	}

	initialize_session(){
        let go_live = this;
        go_live.show_error_message('')
        go_live.width('#go_live_sidebar','500px');
        go_live.height('#subscriber','350px');
        go_live.height('#publisher','100px');
        go_live.hide_section('#waiting_area,.go-live-btn');
        go_live.show_section('#videos');
        
        go_live.session = OT.initSession(face_2_face_data.apiKey, go_live.config.sessionId);
        
        // Subscribe to a newly created stream
        //var subscriber;
        go_live.session.on('streamCreated', function(event) {

            go_live.subscriber = go_live.session.subscribe(event.stream, 'subscriber', {
                insertMode: 'append',
                width: '100%',
                height: '100%'
            }, go_live.handle_error);

            go_live.subscriber.on({
                disconnected: function() {
                    go_live.disconnect();
                    go_live.show_error_message('Call Disconnected due to some technical error.');
                },
                connected: function() {
                    
                },
                destroyed: function() {
                    go_live.disconnect();
                }
              });

        });

        // Create a publisher
        go_live.publisher = OT.initPublisher('publisher', {
            insertMode: 'append',
            width: '100%',
            height: '100%'
        }, go_live.handle_error);

        // Connect to the session
        go_live.session.connect(go_live.config.tokboxToken, function(error) {
            // If the connection is successful, initialize a publisher and publish to the session
            if (error) {
                go_live.handle_error(error);
            } else {
                go_live.session.publish(go_live.publisher, go_live.handle_error);
                
                
            }
        });

        go_live.publisher.on("streamDestroyed", function (event) {
            event.preventDefault();
            console.log("The publisher stopped streaming. Reason: "+ event.reason);
            go_live.show_error_message("The publisher stopped streaming. Reason: "+ event.reason);
            
        });
        go_live.show_message_option();
        
    }

    request_f2fn($form){
        let go_live = this;
        let data = jQuery($form).serialize();
        data = data+'&action=face2face_request&f2fn='+face_2_face_data.f2fn+'&seller_id='+face_2_face_data.reciever.ID;
        jQuery.ajax({ 
                data: data,
                type: 'post',
                url: face_2_face_data.ajax_url,
                success: function(response) {			
                if(response.status){
                    go_live.show_error_message(response.message);
                    
                    if(response.data.sessionId!='' && response.data.tokboxToken!=''){
                        go_live.config.tokboxToken=response.data.tokboxToken;
                        go_live.config.sessionId=response.data.sessionId;
                        clearInterval(go_live.count_donw_interval);
                        go_live.initialize_session();
                    } else {
                        go_live.interval_count_down();
                        go_live.connect_vendor();
                    }
                    go_live.show_section('#waiting_area');
                    go_live.hide_section('.go-live-btn');
                } else {
                    go_live.show_error_message(response.message);
                }
            },
            error:function(error){
                console.log(error);
            }
        });
    }

    request_go_live(){
        let go_live = this;
        jQuery.ajax({ 
                data: {action: 'face2face_request', f2fn: face_2_face_data.f2fn,seller_id:face_2_face_data.reciever.ID  },
                type: 'post',
                url: face_2_face_data.ajax_url,
                success: function(response) {			
                if(response.status){
                    go_live.show_error_message(response.message);
                    
                    if(response.data.sessionId!='' && response.data.tokboxToken!=''){
                        go_live.config.tokboxToken=response.data.tokboxToken;
                        go_live.config.sessionId=response.data.sessionId;
                        clearInterval(go_live.count_donw_interval);
                        go_live.initialize_session();
                    } else {
                        go_live.interval_count_down();
                        go_live.connect_vendor();
                    }
                    go_live.show_section('#waiting_area');
                    go_live.hide_section('.go-live-btn');
                } else {
                    go_live.show_error_message(response.message);
                }
            },
            error:function(error){
                console.log(error);
            }
        });
    }

    handle_error(error){
        if (error) {
            alert(error.message);
        }
    }

    show_message_option(){
    	let go_live = this;
    	var msgHistory = document.querySelector('#history');
        go_live.session.on('signal:msg', function signalCallback(event) {
            var msg = document.createElement('p');
            var main_title = document.createElement('p');
            var msg_container = document.createElement('div');
            var msg_sender_img = document.createElement('img');
            var message_data = face_2_face_data.reciever;
            if(event.from.connectionId === go_live.session.connection.connectionId){
            	message_data = face_2_face_data.customer;
                
            }

            msg_sender_img.setAttribute('src', message_data.avtar);
            main_title.appendChild(msg_sender_img);
            main_title.appendChild(document.createTextNode(message_data.display_name));
            msg_container.appendChild(main_title);
            
            msg.textContent = event.data;
            msg_container.className = event.from.connectionId === go_live.session.connection.connectionId ? 'mine' : 'theirs';
            msg_container.appendChild(msg);
            msgHistory.appendChild(msg_container);
            msg.scrollIntoView();
        });
    }
	
	connect_vendor(){
        let go_live = this;
        go_live.go_live_connect = setInterval(function() {
            jQuery.ajax({ 
                    data: {action: 'face2face_check_vendor', f2fn: face_2_face_data.f2fn,seller_id:face_2_face_data.reciever.ID },
                    type: 'post',
                    url: face_2_face_data.ajax_url,
                    success: function(response) {			
                    if(response.status){
                        if(response.status=='started'){
                            if(response.data.sessionId!='' && response.data.tokboxToken!=''){
                                clearInterval(go_live.go_live_connect);
                                go_live.config.tokboxToken=response.data.tokboxToken;
                                go_live.config.sessionId=response.data.sessionId;
                                go_live.initialize_session();
                            }
                        } else if(response.status=='declined'){
                            go_live.leave_go_live_customer(false);
                            go_live.show_error_message(response.message);
                        } else {
                            go_live.show_error_message(response.message);
                        }
                    }
                },
                error:function(error){
                    console.log(error);
                }
            });
        }, 10000);
    }

	disconnect(){
        this.show_error_message('Call Ended. Hope you Enjoy.');
        this.leave_go_live_customer(true);
    }

    interval_count_down(){
        let go_live = this;
        go_live.count_donw_interval = setInterval(function() {
            go_live.countDownTime--;
            go_live.hide_section("#go_live_btns");
            if (go_live.countDownTime < 0) {
            	go_live.show_error_message('Vendor is taking time to respond.');
            	go_live.show_section("#go_live_btns");
                clearInterval(go_live.count_donw_interval);
            } else{
                document.getElementById("count-down").innerHTML = go_live.countDownTime+' sec';
            }
        }, 1000);
    }

    leave_go_live_customer(isEnded){
    	let go_live = this;
        clearInterval(go_live.go_live_connect);
        clearInterval(go_live.count_donw_interval);
        this.countDownTime = 45;
        this.height('#subscriber','0px');
        this.height('#publisher','0px');
        go_live.show_section('.go-live-btn,#go_live_toggle');
        go_live.hide_section('#waiting_area,#videos,.go-live-content-wrapper');
        go_live.width('#go_live_sidebar','300px');
        jQuery("#chatContainer").html('');
        if(isEnded){
            jQuery.ajax({
                data: {action: 'face2face_leave_customer', f2fn: face_2_face_data.f2fn,seller_id:face_2_face_data.reciever.ID  },
                type: 'post',
                url: face_2_face_data.ajax_url,
                success: function(response) {	
                    if(response.status){
                        if(go_live.session)
                            go_live.session.unsubscribe(go_live.subscriber);
                            
                        go_live.publisher.destroy();
                        go_live.show_error_message('');
                    }
                },
                error:function(error){
                    console.log(error);
                }
            });
        } else {
            setTimeout(go_live.show_error_message(''),2000);
        }
        
    }

    drag_start(eve) {
        var style = window.getComputedStyle(eve.target, null);
        eve.dataTransfer.setData("text",
        (parseInt(style.getPropertyValue("left"),10) - eve.clientX) + ',' + (parseInt(style.getPropertyValue("top"),10) - eve.clientY));
    } 

    drag_over(event) { 
        event.preventDefault(); 
        return false; 
    }

    drop(event) { 
        var offset = event.dataTransfer.getData("text").split(','); 
        var dm = document.getElementById('go_live_move');
        dm.style.left = (event.clientX + parseInt(offset[0],10)) + 'px';
        dm.style.top = (event.clientY + parseInt(offset[1],10)) + 'px';
        event.preventDefault();
        return false;
    }

}
var goLive = new GoLive();

jQuery(document).ready(function(){
    var dm = document.getElementById('go_live_move'); 
    if(dm!=null){
        dm.addEventListener('dragstart',goLive.drag_start,false); 
        document.body.addEventListener('dragover',goLive.drag_over,false); 
        document.body.addEventListener('drop',goLive.drop,false); 
        var form = document.querySelector('#chatbox');
        var msgTxt = document.querySelector('#msgTxt');
        if(form!=null){
            // Send a signal once the user enters data in the form
            form.addEventListener('submit', function submit(event) {
                
              event.preventDefault();

              goLive.session.signal({
                type: 'msg',
                data: msgTxt.value
              }, function signalCallback(error) {
                if (error) {
                  console.error('Error sending signal:', error.name, error.message);
                } else {
                  msgTxt.value = '';
                }
              });
            });
        }
        
    }
});

jQuery(document).on('click','#go_live_toggle', function(){
    goLive.hide_section("#go_live_toggle");
    goLive.show_section('.go-live-content-wrapper');
});

jQuery(document).on('click','#request_go_live', function(){
	goLive.request_go_live();
});

jQuery(document).on('submit','#f2fn', function(event){
    event.preventDefault();
	return goLive.request_f2fn(this);
});

jQuery(document).on('click','#leave_go_live,#stop_video', function(){
    goLive.leave_go_live_customer(true);
});

jQuery(document).on('click','#go_live_wait_more_btn',function(){
    goLive.countDownTime = 30;
    goLive.interval_count_down();
});